#
# Conditional build:
%bcond_without	dtls_srtp	# DTLS SRTP support
%bcond_without	static_libs	# static libraries

%if %{with dtls_srtp}
%define		mbedtls_ver	2.26.0-1
%else
%define		mbedtls_ver	2
%endif
Summary:	Utility library for software from Belledonne Communications
Summary(pl.UTF-8):	Biblioteka narzędziowa dla oprogramowania firmy Belledonne Communications
Name:		bctoolbox
Version:	5.3.26
Release:	1
License:	GPL v3+
Group:		Libraries
#Source0Download: https://gitlab.linphone.org/BC/public/bctoolbox/tags
Source0:	https://gitlab.linphone.org/BC/public/bctoolbox/-/archive/%{version}/%{name}-%{version}.tar.bz2
# Source0-md5:	a96dfdc65b3771476abefcf50ad8469b
Patch0:		%{name}-decaf-shared.patch
URL:		https://linphone.org/
BuildRequires:	bcunit-devel >= 5.3.0
BuildRequires:	cmake >= 3.22
BuildRequires:	libdecaf-devel >= 1.0.2
BuildRequires:	libstdc++-devel >= 6:7
BuildRequires:	mbedtls-devel >= %{mbedtls_ver}
BuildRequires:	sed >= 4.0
Requires:	libdecaf >= 1.0.2
Requires:	mbedtls >= %{mbedtls_ver}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Utilities library used by Belledonne Communications softwares like
belle-sip, mediastreamer2 and linphone.

%description -l pl.UTF-8
Biblioteka narzędziowa używana w oprogramowaniu firmy Belledonne
Communications, takim jak belle-sip, mediastreamer2 czy linphone.

%package devel
Summary:	Header files for bctoolbox libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek bctoolbox
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libdecaf-devel >= 1.0.2
Requires:	mbedtls-devel >= %{mbedtls_ver}

%description devel
Header files for bctoolbox libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek bctoolbox.

%package static
Summary:	Static bctoolbox libraries
Summary(pl.UTF-8):	Statyczne biblioteki bctoolbox
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static bctoolbox libraries.

%description static -l pl.UTF-8
Statyczne biblioteki bctoolbox.

%prep
%setup -q
%patch0 -p1

%build
%if %{with static_libs}
%cmake -B builddir-static \
	-DBUILD_SHARED_LIBS=OFF \
	-DENABLE_UNIT_TESTS=OFF

%{__make} -C builddir-static
%endif

%cmake -B builddir

%{__make} -C builddir

%install
rm -rf $RPM_BUILD_ROOT

%if %{with static_libs}
%{__make} -C builddir-static install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%{__make} -C builddir install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CHANGELOG.md README.md
%attr(755,root,root) %{_libdir}/libbctoolbox.so.1
%attr(755,root,root) %{_libdir}/libbctoolbox-tester.so.1

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/bctoolbox-tester
%attr(755,root,root) %{_libdir}/libbctoolbox.so
%attr(755,root,root) %{_libdir}/libbctoolbox-tester.so
%{_includedir}/bctoolbox
%{_pkgconfigdir}/bctoolbox.pc
%{_pkgconfigdir}/bctoolbox-tester.pc
%dir %{_datadir}/BCToolbox
%{_datadir}/BCToolbox/cmake

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libbctoolbox.a
%{_libdir}/libbctoolbox-tester.a
%endif
%changelog
* Tue Apr 02 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/bctoolbox.git;a=log;h=master

* Tue Mar 05 2024 Jakub Bogusz <qboosh@pld-linux.org> bb331f8
- requires bcunit 5.3 due to cmake config files rename

* Tue Mar 05 2024 Jakub Bogusz <qboosh@pld-linux.org> 9299716
- updated to 5.3.26

* Sat Apr 08 2023 Jakub Bogusz <qboosh@pld-linux.org> 0535db4
- added patch to remove two unused functions which trigger use-after-free warning

* Sat Apr 08 2023 Jakub Bogusz <qboosh@pld-linux.org> bc11c58
- updated to 5.2.49
- added mbledtlsv3 patch (mbedtls 3 support backported from git master)
- requires libdecaf with keypair API

* Tue Apr 26 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> 1b18c16
- Link with mbedtls2 until it is fully ported to mbedtls 3

* Tue Apr 19 2022 Arkadiusz Miśkiewicz <arekm@maven.pl> cf70f83
- Partial mbedtls 3.0 update

* Tue Apr 05 2022 Jan Rękorajski <baggins@pld-linux.org> d77c8f0
- rel 0.1, does not build with mbedtls 3

* Tue Apr 05 2022 Jan Rękorajski <baggins@pld-linux.org> d11c13e
- up to 5.1.17

* Tue Apr 05 2022 Jan Rękorajski <baggins@pld-linux.org> 6fad27b
- Release 2 (by relup.sh)

* Thu Jun 17 2021 Jakub Bogusz <qboosh@pld-linux.org> bea354b
- use build dir separate from "build" directory included in sources

* Thu Jun 17 2021 Jakub Bogusz <qboosh@pld-linux.org> a3fd20e
- disabling STRICT no longer required

* Thu Jun 17 2021 Jakub Bogusz <qboosh@pld-linux.org> befde7d
- updated to 4.5.20

* Mon Jun 14 2021 Jakub Bogusz <qboosh@pld-linux.org> ef607d1
- turn off ENABLE_STRICT (because of mbedtls vs gcc 11 -Werror=stringop-overflow)

* Mon Jun 14 2021 Jakub Bogusz <qboosh@pld-linux.org> beede8b
- updated to 4.5.15
- added dtls_srtp bcond to ensure DTLS SRTP support in mbedtls

* Mon Jan 04 2021 Jan Rękorajski <baggins@pld-linux.org> 220521e
- release 2 (by relup.sh)

* Sat Sep 26 2020 Jakub Bogusz <qboosh@pld-linux.org> 232d9ea
- updated to 4.4.0

* Mon Apr 22 2019 Jakub Bogusz <qboosh@pld-linux.org> 581c639
- disable installation completeness check in packaged cmake files, added -static, release 2

* Wed Sep 26 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 82032e8
- initial

